## net.sf.saxon.functions
Class FormatNumber

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.FormatNumber

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, SequenceIterable, XSLTFunction, InstructionInfo, org.xml.sax.Locator

    public class FormatNumber

extends SystemFunction
implements XSLTFunction

XSLT 2.0 implementation of format-number() function - removes the dependence on the JDK.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.functions.SystemFunction
`operation`

Fields inherited from class net.sf.saxon.expr.FunctionCall
`argument`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`FormatNumber()`

Method Summary
`static java.math.BigDecimal` `adjustToDecimal(double value, int precision)` Convert a double to a BigDecimal.
`void` `checkArguments(ExpressionVisitor visitor)` Method called during static type checking
`java.lang.CharSequence` `evaluateAsString(XPathContext context)` Evaluate in a context where a string is wanted
`Item` `evaluateItem(XPathContext c)` Evaluate in a general context
`void` `fixup(DecimalSymbols dfs)` Fixup: this is a callback from the DecimalFormatManager used once the xsl:decimal-format element is identified
`Expression` `preEvaluate(ExpressionVisitor visitor)` preEvaluate: this method suppresses compile-time evaluation by doing nothing.

Methods inherited from class net.sf.saxon.functions.SystemFunction
`addContextDocumentArgument, addDocToPathMap, computeCardinality, computeSpecialProperties, copy, getDetails, getErrorCodeForTypeErrors, getItemType, getRequiredType, makeSystemFunction, optimize, setDetails, useContextItemAsDefault`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`addExternalFunctionCallToPathMap, checkArgumentCount, equals, explain, getArguments, getDisplayName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, promote, replaceSubExpression, setArguments, setFunctionName, simplify, simplifyArguments, toString, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, display, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isUpdatingExpression, iterate, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FormatNumber

    public FormatNumber()

Method Detail

### checkArguments

    public void checkArguments(ExpressionVisitor visitor)
                        throws XPathException

  Description copied from class: `SystemFunction`
  Method called during static type checking

  Overrides:
    `checkArguments` in class `SystemFunction`
  Parameters:
    `visitor` - the expression visitor
  Throws:
    `XPathException`

### fixup

    public void fixup(DecimalSymbols dfs)

  Fixup: this is a callback from the DecimalFormatManager used once the xsl:decimal-format element is identified

  Parameters:
    `dfs` - the decimal symbols to be used

### preEvaluate

    public Expression preEvaluate(ExpressionVisitor visitor)
                           throws XPathException

  preEvaluate: this method suppresses compile-time evaluation by doing nothing. We can't evaluate early because we don't have access to the DecimalFormatManager.

  Overrides:
    `preEvaluate` in class `FunctionCall`
  Parameters:
    `visitor` - the expression visitor
  Returns:
    the result of the early evaluation, or the original expression, or potentially a simplified expression
  Throws:
    `XPathException`

### evaluateAsString

    public java.lang.CharSequence evaluateAsString(XPathContext context)
                                            throws XPathException

  Evaluate in a context where a string is wanted

  Overrides:
    `evaluateAsString` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the value of the expression, evaluated in the current context. The expression must return a string or (); if the value of the expression is (), this method returns "".
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext c)
                      throws XPathException

  Evaluate in a general context

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `c` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### adjustToDecimal

    public static java.math.BigDecimal adjustToDecimal(double value,
                                                       int precision)

  Convert a double to a BigDecimal. In general there will be several BigDecimal values that are equal to the supplied value, and the one we want to choose is the one with fewest non-zero digits. The algorithm used is rather pragmatic: look for a string of zeroes or nines, try rounding the number down or up as approriate, then convert the adjusted value to a double to see if it's equal to the original: if not, use the original value unchanged.

  Parameters:
    `value` - the double to be converted
    `precision` - 2 for a double, 1 for a float
  Returns:
    the result of conversion to a double

Copyright (c) Saxonica Limited. All rights reserved.